---
_field: &_field

  class:
    category: data
    default: od
    flatten: false
    type: enum
    values:
    - [at, austria]
    - [be, belgium]
    - [c3, c3s]
    - [ce, cems]
    - [ch, switzerland]
    - [co, cosmo]
    - [cr, cams research]
    - [cs, ecsn]
    - [de, germany]
    - [dk, denmark]
    - [dm, demeter]
    - [dt, dts]
    - [e2, e20c]
    - [e4, reanalyse40]
    - [ea, era5, esat]
    - [ei, era interim]
    - [el, eldas]
    - [em, e20cm]
    - [en, ensembles]
    - [ep, cera-20c, cera20c]
    - [er, reanalyse]
    - [es, spain]
    - [et, cera-sat, cerasat]
    - [fi, finland]
    - [fr, france]
    - [gr, greece]
    - [gw, global wildfire information system]
    - [hr, croatia]
    - [hu, hungary]
    - [ie, ireland]
    - [is, iceland]
    - [it, italy]
    - [j5, jra55]
    - [l5, era5l]
    - [la, aladin-laef, laef, lace]
    - [ma, metaps]
    - [mc, macc]
    - [me, mersea]
    - [nl, netherlands]
    - ['no', norway]
    - [nr, ncep 20cr, 20cr]
    - [od, operations]
    - [pe, permanent experiment]
    - [pt, portugal]
    - [pv, provost]
    - [rd, research]
    - [rm, euro4m]
    - [rr, regional reanalysis]
    - [se, sweden]
    - [si, slovenia]
    - [sr, sreps]
    - [te, test]
    - [to, tost]
    - [tr, turkey]
    - [uk, united kingdom]
    - [ul, ulysses]
    - [ur, uerra]
    - [yt, yotc]

  type:
    category: data
    default: an
    flatten: false
    type: enum
    values:
    - [3g, 3d variational gradients]
    - [3v, 3d variational analysis]
    - [4g, 4d variational gradients]
    - [4i, 4d variational increments]
    - [4v, 4d variational analysis]
    - [ab, analysis bias]
    - [af, analysis feedback]
    - [ai, analysis input]
    - [an, analysis]
    - [as, adjoint singular vector]
    - [bf, bias-corrected forecast]
    - [cd, climate distribution]
    - [cf, control forecast]
    - [ci, clustering information]
    - [cl, climatology]
    - [cm, cluster means]
    - [cr, cluster representative]
    - [cs, cluster std deviations]
    - [cv, calibration validation forecast]
    - [ea, errors in analysis]
    - [ed, empirical distribution]
    - [ef, errors in first guess]
    - [efi, extreme forecast index]
    - [efic, extreme forecast index control]
    - [em, ensemble mean]
    - [eme, ensemble data assimilation model errors]
    - [emtm, ensemble mean of temporal mean]
    - [ep, event probability]
    - [es, ensemble standard deviation]
    - [estdtm, ensemble standard deviation of temporal mean]
    - [fa, forecast accumulation]
    - [fb, feedback]
    - [fc, forecast]
    - [fcdfb, forecast departures feedback]
    - [fcmax, forecast maximum]
    - [fcmean, forecast mean]
    - [fcmin, forecast minimum]
    - [fcstdev, forecast standard deviation]
    - [ff, flux forcing realtime]
    - [fg, first guess]
    - [fp, forecast probability]
    - [fsoifb, forecast sensitivity to observations impact feedback]
    - [fu, fill-up]
    - [fx, flux forcing]
    - [ga, gfas analysis]
    - [gai, gridded analysis input]
    - [go, gridded observations]
    - [gsd, gridded satellite data]
    - [hcmean, hindcast mean]
    - [ia, init. analysis]
    - [icp, initial condition perturbation]
    - [im, images]
    - [me, model errors]
    - [mfb, mondb feedback]
    - [oai, odb analysis input]
    - [ob, observations]
    - [of, ocean forward]
    - [ofb, odb feedback]
    - [oi, oi analysis]
    - [oldim, old format images]
    - [or, ocean reanalysis]
    - [pa, perturbed analysis]
    - [pb, probability boundary]
    - [pd, probability distribution]
    - [pf, perturbed forecast]
    - [s3, climate 30 days simulation]
    - [ses, scaled ensemble standard deviation]
    - [sf, sensitivity forecast]
    - [sfb, summary feedback]
    - [sfo, simulations with forcing]
    - [sg, sensitivity gradient]
    - [si, climate simulation]
    - [sim, simulated images]
    - [sot, shift of tails]
    - [ssd, simulated satellite data]
    - [sv, singular vector]
    - [svar, signal variance]
    - [taem, time average ensemble mean]
    - [taes, time average ensemble standard deviation]
    - [tf, trajectory forecast]
    - [tu, tube]
    - [wem, weighted ensemble mean]
    - [wes, weighted ensemble standard deviation]
    - [wp, weather parameters]

  stream:
    category: data
    default: oper
    flatten: false
    type: enum
    values:
    - [amap, analysis for multianalysis project]
    - [ammc, melbourne]
    - [cher, ch, chernobyl]
    - [cnrm, meteo france climate centre]
    - [cwao, montreal]
    - [dacl, daily climatology]
    - [dacw, daily climatology wave]
    - [dahc, daily archive hindcast]
    - [dcda, atmospheric model (delayed cutoff)]
    - [dcwv, wave model (delayed cutoff)]
    - [edmm, ensemble data assimilation monthly means]
    - [edmo, ensemble data assimilation monthly means of daily means]
    - [edzw, offenbach]
    - [eefh, extended ensemble forecast hindcast]
    - [eefo, extended ensemble prediction system]
    - [eehs, extended ensemble forecast hindcast statistics]
    - [efas, european flood awareness system (efas)]
    - [efcl, european flood awareness system (efas) climatology]
    - [efhc, ensemble forecast hindcasts (obsolete)]
    - [efho, ensemble forecast hindcast overlap]
    - [efhs, ensemble forecast hindcast statistics]
    - [efov, ensemble forecast overlap]
    - [efrf, european flood awareness system (efas) reforecasts]
    - [efse, european flood awareness system (efas) seasonal forecasts]
    - [efsr, european flood awareness system (efas) seasonal reforecasts]
    - [egrr, exeter, bracknell]
    - [ehmm, combined multi-model hindcast monthly means]
    - [elda, ensemble long window data assimilation]
    - [enda, ensemble data assimilation]
    - [enfh, ensemble forecast hindcasts]
    - [enfo, ef, ensemble prediction system]
    - [enwh, ensemble forecast wave hindcasts]
    - [esmm, combined multi-model monthly means]
    - [espd, ensemble supplementary data]
    - [ewda, ensemble wave data assimilation]
    - [ewhc, wave ensemble forecast hindcast (obsolete)]
    - [ewho, ensemble forecast wave hindcast overlap]
    - [ewla, ensemble wave long window data assimilation]
    - [ewmm, ensemble wave data assimilation monthly means]
    - [ewmo, ensemble wave data assimilation monthly means of daily means]
    - [fgge, fg]
    - [fsob, forecast sensitivity to observations]
    - [fsow, forecast sensitivity to observations wave]
    - [gfas, global fire assimilation system]
    - [kwbc, washington]
    - [lfpw, paris, toulouse]
    - [lwda, long window daily archive]
    - [lwwv, long window wave]
    - [ma, means archive]
    - [maed, multianalysis ensemble data]
    - [mawm, wave anomaly means]
    - [mawv, multianalysis wave data]
    - [mdfa, monthly means of daily forecast accumulations]
    - [mfam, anomaly means]
    - [mfaw, wave anomalies]
    - [mfhm, hindcast means]
    - [mfhw, monthly forecast hindcasts wave]
    - [mfwm, wave real-time means]
    - [mhwm, wave hindcast means]
    - [mmaf, multi-model multi-annual forecast]
    - [mmam, multi-model multi-annual forecast means]
    - [mmaw, multi-model multi-annual forecast wave]
    - [mmsa, multi-model seasonal forecast monthly anomalies]
    - [mmsf, multi-model seasonal forecast]
    - [mmwm, multi-model multi-annual forecast wave means]
    - [mnfa, anomalies]
    - [mnfc, real-time]
    - [mnfh, hindcasts]
    - [mnfm, real-time means]
    - [mnfw, wave real-time]
    - [mnth, mo, monthly, monthly means]
    - [mnvr, monthly variance and covariance data using g. boer's step function]
    - [moda, monthly means of daily means]
    - [mofc, monthly forecast]
    - [mofm, monthly forecast means]
    - [monr, monthly means using g. boer's step function]
    - [mpic, max plank institute]
    - [msda, monthly standard deviation and covariance of daily means]
    - [msdc, mv, monthly standard deviation and covariance]
    - [msmm, multi-model seasonal forecast atmospheric monthly means]
    - [mswm, multi-model seasonal forecast wave monthly means]
    - [ocea, ocean]
    - [oper, da, daily archive, atmospheric model]
    - [rjtd, tokyo]
    - [scda, atmospheric model (short cutoff)]
    - [scwv, wave model (short cutoff)]
    - [seap, sensitive area prediction]
    - [seas, seasonal forecast]
    - [sens, sf, sensitivity forecast]
    - [sfmm, seasonal forecast atmospheric monthly means]
    - [smma, seasonal monthly means anomalies]
    - [supd, sd, deterministic supplementary data]
    - [swmm, seasonal forecast wave monthly means]
    - [toga, tg]
    - [ukmo, ukmo climate centre]
    - [waef, we, wave ensemble forecast]
    - [wamd, wave monthly means of daily means]
    - [wamf, wave monthly forecast]
    - [wamo, wave monthly means]
    - [wams, multi-model seasonal forecast wave]
    - [wasf, wave seasonal forecast]
    - [wave, wv, wave model]
    - [wavm, wave model (standalone)]
    - [weef, wave extended ensemble forecast]
    - [weeh, wave extended ensemble forecast hindcast]
    - [wees, wave extended ensemble forecast hindcast statistics]
    - [wehs, wave ensemble forecast hindcast statistics]
    - [weov, wave ensemble forecast overlap]
    - [wfas, global flood awareness system (glofas)]
    - [wfcl, global flood awareness system (glofas) climatology]
    - [wfrf, global flood awareness system (glofas) reforecasts]
    - [wfse, global flood awareness system (glofas) seasonal forecasts]
    - [wfsr, global flood awareness system (glofas) seasonal reforecasts]
    - [wmfm, wave monthly forecast means]
    - [wvhc, wave hindcast]
  expver:
    category: data
    default: '0001'
    flatten: false
    type: expver

  dataset:
    # flatten: false
    multiple: true
    type: any

  model:
    category: data
    type: any

  repres:
    flatten: false
    multiple: true
    type: enum
    values:
    - gg
    - sh
    - ll
    - np
    - rl

  obsgroup:
    category: data
    multiple: true
    type: enum
    values:
    # - [conventional]
    - [sat, satellite]
    - [ers1]
    - [trmm]
    - [qscat]
    - [reo3] # reo3 needs to stay for compatibility
    # previously in "obsgroups.def"
    - [hirs, 1,  HIRS ]
    - [amsua, 2,  AMSUA ]
    - [amsub, 3,  AMSUB ]
    - [mhs, 4,  MHS ]
    - [geos, 5,  GEOS ]
    - [resat, 6,  RESAT ]
    - [meris, 7,  MERIS ]
    - [gpsro, 8,  GPSRO ]
    - [satob, 9,  SATOB ]
    - [scatt, 10,  SCATT ]
    - [ssmi_as, 11,  SSMI ALL-SKY ]
    - [iasi, 12,  IASI ]
    - [airs, 13,  AIRS ]
    - [ssmis_as, 14,  SSMIS ALL-SKY ]
    - [tmi_as, 15,  TMI ALL-SKY ]
    - [amsre_as, 16,  AMSRE ALL-SKY ]
    - [conv, 17,  CONV ]
    - [smos, 19,  SMOS ]
    - [windsat_as, 20,  WINDSAT ALL-SKY ]
    - [ssmi, 21,  SSMI ]
    - [amsua_as, 22,  AMSUA ALL-SKY ]
    - [amsre, 23,  AMSRE ]
    - [tmi, 24,  TMI ]
    - [ssmis, 25,  SSMIS ]
    - [gbrad, 26,  GBRAD ]
    - [mwhs, 27,  MWHS ]
    - [mwts, 28,  MWTS ]
    - [mwri_as, 29,  MWRI ALL-SKY ]
    - [iras, 30,  IRAS ]
    - [msu, 31,  MSU ]
    - [ssu, 32,  SSU ]
    - [vtpr1, 33,  VTPR1 ]
    - [vtpr2, 34,  VTPR2 ]
    - [atms, 35,  ATMS ]
    - [resat_ak, 36,  RESAT AVERAGING KERNELS ]
    - [cris, 37,  CRIS ]
    - [wave_ip, 38,  WAVE INTEGRATED PARAMETERS ]
    - [wave_sp, 39,  WAVE SPECTRA ]
    - [raingg, 40,  RAINGG ]
    - [sfc_ms, 41,  SURFACE MULTISENSOR ]
    - [amsr2_as, 42,  AMSR-2 ALL-SKY ]
    - [saphir_as, 43,  SAPHIR ALL-SKY ]
    - [amsub_as, 44,  AMSUB ALL-SKY ]
    - [mhs_as, 45,  MHS ALL-SKY ]
    - [dwl, 46,  DOPPLER WIND LIDAR ]
    - [iris, 47,  IRIS ]
    - [aatsr, 49,  AATSR ]
    - [atms_as, 50,  ATMS ALL-SKY ]
    - [gmi_as, 51,  GMI ALL-SKY ]
    - [godae_sst, 52,  GODAE SEA SURFACE TEMPERATURES ]
    - [atovs_ms, 53,  ATOVS MULTISENSOR ]
    - [atmospheric_composition, 54,  ATMOSPHERIC COMPOSITION ]
    - [non_sfc_ms, 55,  NON-SURFACE MULTISENSOR ]
    - [mwts2, 56,  MWTS2 ]
    - [ssmi_1d, 57,  SSMI 1DVAR TCWV CLOUDY-SKY ]
    - [mwhs2_as, 58,  MWHS2 ALL-SKY ]
    - [ssmt2, 59,  SSMT2 ]
    - [smap, 60,  SMAP ]
    - [tovs_ms, 61,  TOVS MULTISENSOR ]
    - [cloud_r, 62,  CLOUD REFLECTIVITY ]
    - [cloud_l, 63,  CLOUD LIDAR ]
    - [test, 99,  TEST ]

  reportype:
    category: data
    type: any
    multiple: true

  # rdbprefix

  levtype:
    category: data
    default: pl
    flatten: false
    type: enum
    values:
    - [cat, category]
    - [dp, depth]
    - [layer]
    - [ml, model levels]
    - [pl, pressure levels]
    - [pt, potential temperature]
    - [pv, potential vorticity]
    - [sfc, surface]
    - [wv, ocean wave]
    never:
    - type: ssd

  levelist:
    category: data
    multiple: true
    by: 1
    default:
    - 1000
    - 850
    - 700
    - 500
    - 400
    - 300
    never:
    - levtype: sfc
    - type: ssd
    type: to-by-list-float

  param:
    category: data
    default: 129
    multiple: true
    type: param
    never:
    - type: [tf, ob]

#################################################################

  # year
  # decade
  # month

  date:
    category: data
    default: 0
    type: date
    multiple: true

  # verify
  # refdate

  hdate:
    category: data
    multiple: true
    only:
    - stream:
      - enfh
      - enwh
      - efho
      - ehmm
      - ewho
      - eefh
      - weeh
    type: integer

  andate:
    category: data
    multiple: true
    type: date

  fcmonth:
    category: data
    multiple: true
    by: 1
    type: to-by-list

  fcperiod:
    category: data
    multiple: true
    type: integer

  time:
    category: data
    default: '1200'
    multiple: true
    type: time

  antime:
    category: data
    multiple: true
    type: time

  # leadtime
  # opttime
  # range

  step:
    category: data
    multiple: true
    by: 12
    default: 0
    type: range
    never:
    - stream:
      - msmm
      - mmsa

  anoffset:
    category: data
    multiple: true
    type: integer

  reference:
    category: data
    multiple: true
    type: integer

#################################################################

  # cluster
  # probability

  number:
    category: data
    multiple: true
    aliases:
    - ensemble
    by: 1
    only:
    - type: [pf, cr, cm, fcmean, fcmin, fcmax, fcstdev, sot, fc, wp]
    never:
    # This is to prevent number with type=fc and stream=oper
    - stream: [oper, wave]
    type: to-by-list

  quantile:
    category: data
    multiple: true
    only:
    - type:
      - pd
      - pb
      - taem
      - cd
      # - sot
    type: enum
    values:
    - '0:3'
    - '1:3'
    - '2:3'
    - '3:3'
    - '0:5'
    - '1:5'
    - '2:5'
    - '3:5'
    - '4:5'
    - '5:5'
    - '0:10'
    - '1:10'
    - '2:10'
    - '3:10'
    - '4:10'
    - '5:10'
    - '6:10'
    - '7:10'
    - '8:10'
    - '9:10'
    - '10:10'
    - '0:100'
    - '1:100'
    - '2:100'
    - '3:100'
    - '4:100'
    - '5:100'
    - '6:100'
    - '7:100'
    - '8:100'
    - '9:100'
    - '10:100'
    - '11:100'
    - '12:100'
    - '13:100'
    - '14:100'
    - '15:100'
    - '16:100'
    - '17:100'
    - '18:100'
    - '19:100'
    - '20:100'
    - '21:100'
    - '22:100'
    - '23:100'
    - '24:100'
    - '25:100'
    - '26:100'
    - '27:100'
    - '28:100'
    - '29:100'
    - '30:100'
    - '31:100'
    - '32:100'
    - '33:100'
    - '34:100'
    - '35:100'
    - '36:100'
    - '37:100'
    - '38:100'
    - '39:100'
    - '40:100'
    - '41:100'
    - '42:100'
    - '43:100'
    - '44:100'
    - '45:100'
    - '46:100'
    - '47:100'
    - '48:100'
    - '49:100'
    - '50:100'
    - '51:100'
    - '52:100'
    - '53:100'
    - '54:100'
    - '55:100'
    - '56:100'
    - '57:100'
    - '58:100'
    - '59:100'
    - '60:100'
    - '61:100'
    - '62:100'
    - '63:100'
    - '64:100'
    - '65:100'
    - '66:100'
    - '67:100'
    - '68:100'
    - '69:100'
    - '70:100'
    - '71:100'
    - '72:100'
    - '73:100'
    - '74:100'
    - '75:100'
    - '76:100'
    - '77:100'
    - '78:100'
    - '79:100'
    - '80:100'
    - '81:100'
    - '82:100'
    - '83:100'
    - '84:100'
    - '85:100'
    - '86:100'
    - '87:100'
    - '88:100'
    - '89:100'
    - '90:100'
    - '91:100'
    - '92:100'
    - '93:100'
    - '94:100'
    - '95:100'
    - '96:100'
    - '97:100'
    - '98:100'
    - '99:100'
    - '100:100'
  domain:
    category: data
    default: g
    flatten: false
    type: enum
    values:
    - [a, north west europe]
    - [b, north east europe, baltic and black sea]
    - [c, south west europe]
    - [d, south east europe]
    - [e, europe]
    - [f, fastex]
    - [g, globe, general european area]
    - [h]
    - [i]
    - [j]
    - [k]
    - [l]
    - [m, mediterranean]
    - ['n', northern hemisphere]
    - [o]
    - [p]
    - [q]
    - [r]
    - [s, southern hemisphere]
    - [t, tropics]
    - [u, tropics 2]
    - [v]
    - [w, western atlantic]
    - [x]
    - ['y']
    - [z]

  frequency:
    category: data
    multiple: true
    by: 1
    only:
    - param:
      - '140251'
    type: to-by-list

  direction:
    category: data
    multiple: true
    by: 1
    only:
    - param:
      - '140251'
    type: to-by-list

  diagnostic:
    category: data
    type: integer
    multiple: true

  iteration:
    category: data
    type: integer
    multiple: true

  channel:
    category: data
    only:
    - type: ssd
    type: integer
    multiple: true

  ident:
    category: data
    only:
    - type: ssd
    type: integer
    multiple: true

  instrument:
    category: data
    only:
    - type: ssd
    type: integer
    multiple: true

  method:
    category: data
    type: integer

  origin:
    category: data
    multiple: true
    type: enum
    values:
    - [ammc, 1, melbourne]
    - [babj, 38, beijing]
    - [cmcc]
    - [cnmc, 80]
    - [consensus, 255]
    - [crfc, 239, cerfacs]
    - [cwao, 54, montreal]
    - [ecmf, 98, ecmwf]
    - [edzw, dwd, 78, offenbach]
    - [egrr, 74, exeter, bracknell]
    - [enmi, 88, oslo]
    - [fnmo, fnmoc, 58, fleet numerical]
    - [hadc, 247, hadley centre]
    - [ifmk, 246]
    - [ingv, 235]
    - [knmi, 245]
    - [kwbc, 7, washington]
    - [lemm, 214, madrid]
    - [lfpw, 84, 85, paris, toulouse]
    - [rjtd, 34, tokyo]
    - [rksl, 40, seoul]
    - [sbsj, 46, cptec]
    - [vuwien, 244, university of vienna]

  system:
    category: data
    type: integer

#######################################################################

_observation: &_observation

  obstype:
    category: data
    type: any
    multiple: true

  obsgroup:
    category: data
    type: any
    multiple: true

#######################################################################

_postproc: &_postproc

  accuracy:
    category: postproc
    flatten: false
    type: [enum, integer]
    values:
    - [av]
    - ['off', normal, auto]

  bitmap:
    category: postproc
    flatten: false
    type: any

  format:
    category: postproc
    flatten: false
    type: enum
    values:
    - - grib
      - grib1
      - gb
    - - grib2
    - - bufr
      - bf
    - - grid
      - gd
    - odb
    - ascii

  frame:
    category: postproc
    type: integer

  gaussian:
    category: postproc
    type: enum
    values:
    - reduced
    - regular

  area:
    category: postproc
    flatten: false
    multiple: true
    type: [float, enum]
    values:
    - ['off', g, global]
    - [e, europe]

  grid:
    category: postproc
    flatten: false
    multiple: true
    type: [enum, float, regex]
    values:
    - auto
    - N16
    - N24
    - N32
    - N48
    - N64
    - N80
    - N96
    - N128
    - N160
    - N200
    - N256
    - N320
    - N400
    - N512
    - N576
    - N640
    - N800
    - N1024
    - N1280
    - N1600
    - N2000
    - N4000
    - N8000
    regex:
    - '^[oOfF][1-9][0-9]+$'
    uppercase: true

  interpolation:
    category: postproc
    flatten: false
    type: enum
    values:
    - - linear
    - - nearest-lsm
      - nearest lsm
    - - 'off'
      - default
      - any

  packing:
    category: postproc
    flatten: false
    type: enum
    values:
    - - so
      - second order
    - ['off', av]
    - [co, complex]
    - simple

  resol:
    category: postproc
    flatten: false
    aliases:
        - tra
    type: [enum, integer]
    values:
    - - 'off'
      - av
      - reduced gaussian 160

  rotation:
    category: postproc
    flatten: false
    multiple: true
    type: float

  intgrid:
    category: postproc
    flatten: false
    type: [enum, regex]
    values:
    - 'off'
    - auto
    - N32
    - N48
    - N64
    - N80
    - N96
    - N128
    - N160
    - N192
    - N200
    - N256
    - N320
    - N400
    - N512
    - N640
    - N800
    - N912
    - N1024
    - N1280
    regex:
    - '^[oOfF][1-9][0-9]+$'

  truncation:
    category: postproc
    flatten: false
    type: [enum, integer]
    values:
    - auto
    - 'off'
#######################################################################

_obspproc: &_obspproc

  filter:
    type: any
    category: postproc

  ident:
    type: any
    category: postproc


#######################################################################

disseminate:
  <<: *_field
  <<: *_postproc

  requirements:
    type: any

  use:
    category: data
    flatten: false
    multiple: true
    type: enum
    values:
    - bc
    - thursday
    - monday

  option:
    default: normal
    flatten: false
    multiple: true
    type: enum
    values:
    - normal
    - delay
    - asap
    - gts
    - opendata

  compatibility:
    category: postproc
    flatten: false
    multiple: true
    type: enum
    values:
    - 'off'
    - 'no-local-extension'

  priority:
    flatten: false
    type: integer

  target:
    flatten: false
    type: any

##############################################################

archive:
  <<: *_field
  <<: *_observation


  database:
    flatten: false
    multiple: true
    type: any

  source:
    flatten: false
    multiple: true
    type: any

  expect:
    flatten: false
    multiple: false
    type: integer

##############################################################

retrieve:

  <<: *_field
  <<: *_observation
  <<: *_postproc
  <<: *_obspproc

  target:
    flatten: false
    multiple: true
    type: any

  expect:
    flatten: false
    multiple: false
    type: integer

  fieldset:
    flatten: false
    multiple: false
    type: any

  database:
    flatten: false
    multiple: true
    type: any

  optimise:
    type: enum
    values:
    - true
    - false
    default:
      "off"

  padding:
    flatten: false
    type: enum
    values:
    - none
    - auto

##############################################################

read:
  source:
    flatten: false
    multiple: true
    type: any

  <<: *_field
  <<: *_observation
  <<: *_postproc
  <<: *_obspproc

  target:
    flatten: false
    multiple: true
    type: any

  fieldset:
    flatten: false
    multiple: false
    type: any

  _defaults:
    class: null
    date: null
    domain: null
    expver: null
    levelist: null
    levtype: null
    param: null
    step: null
    stream: null
    time: null
    type: null

  _options:
    param:
      # expand_with:  # In case not type/stream/levtype is provided
      #   type: an
      #   stream: oper
      #   levtype: pl
      first_rule: true
##############################################################

get:

  tape:
    flatten: false
    multiple: false
    type: any

  database:
    flatten: false
    multiple: true
    type: any

  target:
    flatten: false
    multiple: true
    type: any

##############################################################

list:

  <<: *_field
  <<: *_observation

  database:
    flatten: false
    multiple: true
    type: any

  target:
    flatten: false
    multiple: true
    type: any

  _defaults:
    # class: null
    date: null
    domain: null
    expver: null
    levelist: null
    levtype: null
    param: null
    step: null
    stream: null
    time: null
    type: null

##############################################################

compute:
  formula:
    flatten: false
    multiple: false
    type: any

  fieldset:
    flatten: false
    multiple: false
    type: any

##############################################################

write:

  fieldset:
    flatten: false
    multiple: false
    type: any

  target:
    flatten: false
    multiple: true
    type: any

##############################################################

pointdb:
  lat:
    multiple: false
    type: float

  lon:
    multiple: false
    type: float

  <<: *_field

  _defaults:
    class: null
    date: null
    domain: null
    expver: null
    levelist: null
    levtype: null
    param: null
    step: null
    stream: null
    time: null
    type: null

  _options:
    param:
      # expand_with:  # In case not type/stream/levtype is provided
      #   type: an
      #   stream: oper
      #   levtype: pl
      first_rule: true

end: {}
